local Tasks = Tasks
local L = Tasks.L
local TasksUtils = TasksUtils
local db

Tasks:RegisterCallback("Tasks-Initialize", "EngineInit")

function Tasks:EngineInit()
  db = Tasks.db
  self:RegisterEvent("ENCOUNTER_START")
  self:RegisterEvent("ENCOUNTER_END")
  self:RegisterEvent("PLAYER_LEVEL_UP")
  self:CheckFirstTimeResets()
  self.resetTimer = self:ScheduleRepeatingTimer("CheckReset", 60)
end

function Tasks:ENCOUNTER_START(eventName, encounterId, encounterName, difficulty, raidSize)
  --db.global.encounters[tostring(encounterId)] = encounterName
end
function Tasks:ENCOUNTER_END(eventName, encounterId, encounterName, difficulty, raidSize, endStatus)
  
end

function Tasks:PLAYER_LEVEL_UP(eventName, newLevel)
  db.global.characters[Tasks.currentCharacter].level = newLevel
end

function Tasks:CheckReset()
--  print ("reset for "..time())
  if time() > db.global.nextDailyReset then 
    print ("reset dailys")
    db.global.nextDailyReset = GetNextDailyReset()
  end
  if time() > db.global.nextWeeklyReset then 
    print ("reset weeklies")
    db.global.nextDailyReset = GetNextWeeklyReset()
  end
end

function Tasks:CheckFirstTimeResets()
  if not db.global.nextWeeklyReset then
    db.global.nextWeeklyReset = GetNextWeeklyReset()
  end
  if not db.global.nextDailyReset then
    db.global.nextDailyReset = GetNextDailyReset()
  end
end

local function GetNextDailyReset()
  return time() + GetQuestResetTime()
end

local function GetNextWeeklyReset()
  local nextDailyReset = GetNextDailyReset()
  local daysToReset = db.global.resetOptions.weeklyResetDay - date("*t", nextDailyReset).wday
  if daysToReset < 0 then daysToReset = daysToReset + 7 end
  return nextDailyReset + daysToReset * 24 * 60 * 60
end