Tasks = LibStub("AceAddon-3.0"):NewAddon("Tasks", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
Tasks.L = LibStub("AceLocale-3.0"):GetLocale("Tasks", false)
TasksUtils = {}
Tasks.callbacks = setmetatable({}, {__index = function(tbl, key) tbl[key] = {} return tbl[key] end})


function Tasks:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("TasksDB", self.defaults["db"], true)
  self:UpgradeDBVersion()
  
  --retrieve and store character info
  local char = UnitName("player") .. " - " .. GetRealmName()
  -- local char =  GetUnitName("player", true")
  self.currentChar = char
  self.db.global.characters[char].name = UnitName("player")
  self.db.global.characters[char].realm = GetRealmName()
  self.db.global.characters[char].class = select(2,UnitClass("player"))
  self.db.global.characters[char].level = UnitLevel("player")
  self.db.global.characters[char].race = select(2, UnitRace("player"))
  self.db.global.characters[char].faction = UnitFactionGroup("player")
  
  --initialize various modules
  self:Fire("Tasks-Initialize",nil)
end

function Tasks:OnEnable()
end

function Tasks:OnDisable()

end

function Tasks:UpgradeDBVersion()
  if not(self.db.global.dbVersion) then
    self.db.global.dbVersion = self.constants.CURRENT_DB_VERSION
  end
  
  if(self.db.global.dbVersion == 1) then
    self.db.global.encounters = nil
    self.db.global.dbVersion = 2
  end
  
  if(self.db.global.dbVersion == 2) then
    for k,v in pairs(self.db.global.lists) do
      v.id = k
      for k2,v2 in pairs(v.tasks) do
        v2.id = k2
      end
    end
    self.db.global.editTask = nil
    self.db.global.dbVersion = 3
  end
end

function Tasks:Fire(event, ...)
  for k in pairs(Tasks.callbacks[event]) do
    loadstring('Tasks:'..k..'(...)')(...)
  end
end

function Tasks:RegisterCallback(event, method)
  Tasks.callbacks[event][method] = true
end

function Tasks:UnegisterCallback(event, method)
  Tasks.callbacks[event][method]= nil
end